#include <bits/stdc++.h>
const int maxn=1e5;
int n,q;
int hall[maxn*4];
long long values[maxn];
long long halllazy[maxn*4];
bool hasdivider[maxn];
void hallupdade(int lq,int rq,int ln,int rn, int node,int value)
{
    if(lq>rq or lq<ln or rq>rn)
    {
        return;
    }
    if(lq==ln && rq==rn)
    {
        hall[node]+=value;
        // std::cout<<ln<<" "<<rn<<"\n";
    }
    else
    {
        hall[node*2]+=hall[node];
        hall[node*2+1]+=hall[node];
        hall[node]=0;
        int mid=ln+rn;
        mid/=2;
//std::cout<<ln<<" "<<rn<<" "<<lq<<" "<<rq<<"\n";
// if(lq<mid or rq>=mid){
        hallupdade(lq,std::min(mid,rq),ln,mid,node*2,value);
        hallupdade(std::max(mid+1,lq),rq,mid+1,rn,node*2+1,value);
// }else{
// hallupdade(lq,rq,ln,mid,node*2,value);
// hallupdade(lq,rq,mid+1,rn,node*2+1,value);}
    }
}
int query(int q,int ln,int rn, int node)
{
    if(q<ln or q>rn)
    {
        return -1;
    }
    //  std::cout<<ln<<" "<<rn<<" "<<q<<"\n";
    if(ln==rn && ln==q)
    {
        return hall[node];
    }
    else
    {
        int mid=rn+ln;
        mid/=2;
        //     std::cout<<ln<<" "<<rn<<" "<<mid<<"\n";
        hall[node*2]+=hall[node];
        hall[node*2+1]+=hall[node];
        hall[node]=0;
        if(q>mid)
        {
            return query(q,mid+1,rn,node*2+1);
        }
        return query(q,ln,mid,node*2);


    }
}
long long valuetree[maxn*4];
void buildvaluetree(int ln,int rn, int node);
int valuequerry(int lq,int rq,int ln,int rn,int node);
int main()
{
    std::cin>>n>>q;
    int whatq;
    int l,r,c,a,p;
    bool has4happened=false;
    while(q-->0)
    {
        std::cin>>whatq;
//std::cout<<whatq<<"\n";
        if(whatq==4)
        {
            if(!has4happened)
            {
                int currhall;
                for(int a=0; a<n; a++)
                {
                   
                    if(currhall%2==0)
                    {
                        values[a]=0;
                    } 
                    if(hasdivider[a])
                    {
                        currhall++;
                    }
                    //     std::cout<<values[a]<<" ";
                }
                buildvaluetree(0,n-1,1);
//                //std::cout<<"finished";
//                for(int a=0;a<n*4;a++){
//                    std::cout<<valuetree[a]<<" ";
//                }
//                std::cout<<"\n";
            }
            has4happened=true;
            std::cin>>l>>r;

            std::cout<<valuequerry(l-1,r-1,0,n-1,1)<<"\n";
        }
        else
        {
            switch(whatq)
            {
            case(1):
                std::cin>>p;
                hasdivider[p]=true;
                // hallupdade(p,n-1,0,n-1,1,1);
                //std::cout<<"1 is finite\n";
                break;
            case(2):
                std::cin>>p;
                hasdivider[p]=false;
                // hallupdade(p,n-1,0,n-1,1,-1);
                //std::cout<<"2 is finite\n";
                break;
            case(3):
                std::cin>>c>>a;
                c--;
                values[c]+=a;

                //std::cout<<"3 is finite\n";
                break;

            }
        }
//std::cout<<"\n";
//for(int a=0;a<n*4;a++){
//    std::cout<<hall[a]<<" ";
//}
//std::cout<<"\n";
    }


    return 0;
}
void buildvaluetree(int ln,int rn, int node)
{
    if(ln==rn)
    {
        valuetree[node]=values[ln];
    }
    else
    {
        int mid=ln+rn;
        mid/=2;
        buildvaluetree(mid+1,rn,node*2+1);
        buildvaluetree(ln,mid,node*2);
        valuetree[node]=std::max(valuetree[node*2],valuetree[node*2+1]);
    }
}
int valuequerry(int lq,int rq,int ln,int rn,int node)
{

    if(lq>rq or lq<ln or rq>rn)
    {
        return 0;
    }
    if(lq==ln && rq==rn)
    {
        //    std::cout<<ln<<" "<<rn<<" "<<node<<" "<<valuetree[node]<<" 1 \n";
        return valuetree[node];
    }
    int mid=ln+rn;
    mid/=2;
    //std::cout<<lq<<" "<<rq<<" "<<ln<<" "<<rn<<"\n";
    return std::max(valuequerry(std::max(lq,mid+1),rq,mid+1,rn,node*2+1),valuequerry(lq,std::min(mid,rq),ln,mid,node*2));
}
