#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

const int MAX_N = 1e5 + 42;
const int mod = 1e9 + 7;

typedef long long ll;
//#define int ll

using namespace std;

std::vector< int > v[MAX_N];
std::deque< int > X;

int x[MAX_N];
int y[MAX_N];

std::vector< std::pair< std::pair< int, int >, int > > points;

std::vector< std::pair< int , int > > segments;

signed main (){

    #ifndef LOCAL
        std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
    #endif

    int n, m;
    std::cin >> n >> m;

    for( int i=0 ; i < n ; i++ ){
        std::cin >> x[i] >> y[i];
    }

    for( int i=0 ; i < n ; i++ ){
        int prev = i-1;
        if( prev < 0 ) prev += n;

        int next = (i+1 ) % n;
        if( x[prev] == x[i] and x[i] == x[next] ) continue;
        if( y[prev] == y[i] and y[i] == y[next] ) continue;

        points.push_back({{x[i], y[i]}, i});
    }

    std::sort( points.begin(), points.end(), []( const std::pair< std::pair< int, int >, int >& a,
                                                const std::pair< std::pair< int, int >, int >& b){
                    if( a.first.first != b.first.first ) return a.first.first < b.first.first;
                    return a.first.second < b.first.second;
                });
    int prevX = points[0].first.first;
    int ind = 0;
    int nas = prevX;
    while( ind < n ){
        int startInd = ind;
        while( ind < n and points[ind].first.first == points[ind+1].first.first) ind++;

        cerr << out( ind ) << out( startInd ) << endl;

        std::vector< std::pair< int, int > > curr;
        for( int i = startInd; i <= ind ; i+= 2 )
            curr.push_back({ points[i].first.second, points[i+1].first.second} );

        int indOld = 0;
        int indCurr = 0;
        std::vector< std::pair< int , int > > New;
        while( indOld < segments.size() and indCurr < curr.size() ){

            if( segments[indOld].first == curr[indCurr].second ){
                New.push_back({ curr[indCurr].first, segments[indOld].second });
                indCurr ++;
            }else if( segments[indOld].second == curr[indCurr].first ){
                New.push_back( { segments[indOld].first, curr[indCurr].second });
                indOld ++;
            }else if( segments[indOld].first > curr[indCurr].second ){
                New.push_back( curr[indCurr] );
                indCurr ++;
            }else if( segments[indOld].second < curr[indCurr].first ){
                New.push_back( segments[indOld] );
                indOld ++;
            }else{
                New.push_back({ segments[indOld].first, curr[indCurr].first });
                New.push_back({ curr[indCurr].second, segments[indOld].second });
                indCurr ++;
                segments[indOld] = { curr[indCurr].second, segments[indOld].second };
            }
        }

        while( indOld < segments.size() ) New.push_back( segments[indOld++] );
        while( indCurr < curr.size() ) New.push_back( curr[indCurr++] );

        segments = New;
        bool oke = true;
        for( auto j : segments ){
            if( ( j.second - j.first ) & 1 ) oke = false;
        }

        int currX = points[ind].first.first;


        cerr << out( ind ) << endl;
        for( auto j : segments ) std::cout << j.first << " " << j.second << endl;

        if( oke ){
            if( currX - prevX % 2 == 0 ) nas = std::max( nas, currX);
            else std::max( nas , currX - 1);
        }else break;


    }

    std::cout << nas;

    return 0;
}
