#include<bits/stdc++.h>
using namespace std;

vector<long long> seg(500001);
vector<long long> sb(100001);

void build(long long l, long long r, long long x) {
    if(l == r) {
        seg[x] = sb[x];
        return;
    }
    long long m = (l+r)/2;
    build(l,m,x*2+1);
    build(m+1,r,x*2+2);
    seg[x] = max(seg[x*2+1],seg[x*2+2]);
}

long long calc(long long l, long long r, long long ql, long long qr, long long x) {
    if(qr > ql) {
        return 0;
    }
    if(ql == l && qr == r) {
        return seg[x];
    }
    long long m = (l+r)/2;
    if(qr <= m) {
        return calc(l,m,ql,qr,x*2+1);
    }
    if(ql > m) {
        return calc(m+1,r,ql,qr,x*2+2);
    }
    return max(calc(l,m,ql,m,x*2+1),calc(m+1,r,m+1,qr,x*2+2));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,q,p,a,b,y = 0,ans = 0,x;
    cin >> n >> q;
    y = q;
    vector<long long> br(n+1);
    vector<long long> pr(n+1);
    for(long long i = 0; i < q; i++) {
        cin >> p;
        if(p <= 2) {
            cin >> a;
            br[a+1]++;
        }
        else if(p == 3) {
            cin >> a >> b;
            sb[a]+=b;
        }
        else {
            y = i;
            break;
        }
    }
    build(1,n,0);
    x = 0;
    set<long long> idk;
    idk.insert(n+1);
    for(long long i = 1; i <= n; i++) {
        if(br[i]%2) {
            idk.insert(i);
        }
        br[i]+=br[i-1];
        if(br[i]%2) {
            x = max(x,sb[i]);
        }
        else {
            ans+=x;
            x = 0;
        }
        pr[i] = ans+x;
    }
    for(long long i = y; i < q; i++) {
        if(i != y) {
            cin >> p;
            if(p != 4) {
                return 0;
            }
        }
        cin >> a >> b;
        if(br[a]%2 == 1) {
            long long z = *idk.lower_bound(a+1);
            z = min(z,b);
            cout << pr[b]-pr[z]+calc(1,n,a,z-1,0) << "\n";
        }
        else {
            cout << pr[b]-pr[a-1] << "\n";
        }
    }
    return 0;
}

