#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n, m;

struct Point
{
    int x, y;
};

Point a[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i].x >> a[i].y;
    }

    vector<pair<int, pair<int, int>>> v;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            if (a[i].x == a[j].x)
            {
                v.push_back(make_pair(a[i].x, make_pair(a[i].y, a[j].y)));
            }
        }
    }

    sort(v.begin(), v.end());

    int ans = 0;

    for (int i = 1; i < v.size(); ++i)
    {
        int res = v[i].first;

        if (v[i - 1].first % 2 != res % 2)
        {
            --res;
        }

        if (res < 0)
        {
            continue;
        }

        int maxy = max(v[i].second.first, v[i].second.second);
        int miny = min(v[i].second.first, v[i].second.second);

        //cout << i << " :: " << res << endl;

        bool flag = false;

        for (int j = i - 1; j >= 0; --j)
        {
            maxy = max(maxy, v[j].second.second);
            maxy = max(maxy, v[j].second.first);

            miny = min(miny, v[j].second.second);
            miny = min(miny, v[j].second.first);

            if (res % 2 != v[j].first % 2 || (maxy - miny) % 2 == 1)
            {
                flag = true;
                break;
            }
        }

        if (flag == false)
        {
            ans = max(ans, res);
            break;
        }
    }

    cout << ans << endl;

    return 0;
}

/*
4 10
5 8
10 8
10 4
5 4

6 4
5 0
5 2
3 2
3 4
0 4
0 0

6 2
5 0
5 1
3 1
3 2
0 2
0 0
*/
