#include "zeroes.h"
bool solve(int N, int call)
{
    int matrix[N][N];
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            matrix[i][j] = -1;
            int curr = get_mem(i, j);
            if(curr == 0)
            {
                for(int k = 0; k < N; k++)
                {
                    matrix[k][j] = 0;
                    matrix[i][k] = 0;
                }
            }
            else
            {
                if(matrix[i][j] == -1)
                {
                    matrix[i][j] = curr;
                }
            }
        }
    }
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            set_mem(i, j, matrix[i][j]);
        }
    }
    return true;
}
