#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 100000;
long long points[MAX_N];
int hall[MAX_N];
int N, Q;
long long findBiggest(int from, int to)
{
    long long res = 0;
    for(int i = from; i <= to; i++)
    {
        res = max(res, points[i]);
    }
    return res;
}
int main()
{
    cin >> N >> Q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for(int i = 0; i < Q; i++)
    {
        int type;
        cin >> type;
        if(type == 1)
        {
            int P;
            cin >> P;
            for(int i = P; i < N; i++)
            {
                hall[i]++;
            }
        }
        else if(type == 2)
        {
            int P;
            cin >> P;
            for(int i = P; i < N; i++)
            {
                hall[i]--;
            }
        }
        else if(type == 3)
        {
            int C, A;
            cin >> C >> A;
            C--;
            points[C] += A;
        }
        else if(type == 4)
        {
            long long sum = 0;
            int L, R;
            cin >> L >> R;
            L--;
            R--;
            int currHallStart = -1;
            for(int i = L; i <= R; i++)
            {
                if(hall[R] % 2 == 0 && hall[R] == hall[i])
                {
                    if(currHallStart != -1)
                    {
                        sum += findBiggest(max(L, currHallStart), i - 1);
                        currHallStart = -1;
                    }
                    break;
                }
                if(i == R && hall[R] % 2 != 0)
                {
                    if(currHallStart == -1)
                    {
                        currHallStart = i;
                    }
                    sum += findBiggest(max(currHallStart, L), R);
                    break;
                }
                if(hall[i] % 2 != 0)
                {
                    if(currHallStart == -1)
                    {
                        currHallStart = i;
                    }
                }
                else
                {
                    if(currHallStart != -1)
                    {
                        sum += findBiggest(max(L, currHallStart), i - 1);
                        currHallStart = -1;
                    }
                }
            }
            cout << sum << "\n";
        }
    }
    return 0;
}
