#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 100000;
long long points[MAX_N];
//int hall[MAX_N];
int N, Q;
long long findBiggest(int from, int to)
{
    long long res = 0;
    for(int i = from; i <= to; i++)
    {
        res = max(res, points[i]);
    }
    return res;
}
struct Hall
{
    int hallStart = -1;
    int hallEnd = -1;
};
int maxHall = 0;
Hall halls[MAX_N];
int getHall(int index)
{
    int l = 0, r = maxHall + 1;
    while(l != r - 1)
    {
        int mid = (l + r) / 2;
        if(halls[mid].hallStart <= index && halls[mid].hallEnd >= index)
        {
            return mid;
        }
        if(halls[mid].hallStart > index)
        {
            r = mid;
        }
        else if(halls[mid].hallEnd < index)
        {
            l = mid;
        }
    }
    return l;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> Q;
    halls[0].hallStart = 0;
    halls[0].hallEnd = N - 1;
    for(int q = 0; q < Q; q++)
    {
        int type;
        cin >> type;
        if(type == 1)
        {
            int P;
            cin >> P;
            P--;
            int currHall = getHall(P);
            for(int j = maxHall; j >= 0; j--)
            {
                if(j == currHall)
                {
                    halls[j + 1].hallStart = P + 1;
                    halls[j + 1].hallEnd = halls[j].hallEnd;
                    halls[j].hallEnd = P;
                    break;
                }
                halls[j + 1].hallStart = halls[j].hallStart;
                halls[j + 1].hallEnd = halls[j].hallEnd;
            }
            maxHall++;
        }
        else if(type == 2)
        {
            int P;
            cin >> P;
            P--;
            int currHall = getHall(P);
            for(int j = currHall; j <= maxHall; j++)
            {
                if(j == currHall)
                {
                    halls[j - 1].hallEnd = halls[j].hallEnd;
                    halls[j].hallStart = halls[j + 1].hallStart;
                    halls[j].hallEnd = halls[j + 1].hallEnd;
                }
                else if(j == maxHall)
                {
                    halls[maxHall].hallStart = -1;
                    halls[maxHall].hallEnd = -1;
                }
                else
                {
                    halls[j].hallStart = halls[j + 1].hallStart;
                    halls[j].hallEnd = halls[j + 1].hallEnd;
                }
            }
            maxHall--;
        }
        else if(type == 3)
        {
            int C, A;
            cin >> C >> A;
            C--;
            points[C] += A;
        }
        else if(type == 4)
        {
            long long sum = 0;
            int L, R;
            cin >> L >> R;
            L--;
            R--;
            int startingHall = getHall(L);
            int endingHall = getHall(R);
            for(int j = startingHall; j <= endingHall; j++)
            {
                if(j % 2 != 0)
                {
                    sum += findBiggest(max(L, halls[j].hallStart), min(R, halls[j].hallEnd));
                }
            }
            cout << sum << "\n";
            /*int currHallStart = -1;
            for(int i = L; i <= R; i++)
            {
                if(hall[R] % 2 == 0 && hall[R] == hall[i])
                {
                    if(currHallStart != -1)
                    {
                        sum += findBiggest(max(L, currHallStart), i - 1);
                        currHallStart = -1;
                    }
                    break;
                }
                if(i == R && hall[R] % 2 != 0)
                {
                    if(currHallStart == -1)
                    {
                        currHallStart = i;
                    }
                    sum += findBiggest(max(currHallStart, L), R);
                    break;
                }
                if(hall[i] % 2 != 0)
                {
                    if(currHallStart == -1)
                    {
                        currHallStart = i;
                    }
                }
                else
                {
                    if(currHallStart != -1)
                    {
                        sum += findBiggest(max(L, currHallStart), i - 1);
                        currHallStart = -1;
                    }
                }
            }
            cout << sum << "\n";*/
        }
    }
    return 0;
}
