#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int x[MAXN + 5], y[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; ++ i)
    {
        cin >> x[i] >> y[i];
    }

    int l = 0, r = m + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        bool flag = true;
        int x0 = x[0];
        for (int i = 0; i < n; ++ i)
        {
            if (y[i] != y[(n + i - 1) % n]) x0 = x[i];
            if (y[i] != y[(i + 1) % n])
            {
                if (x0 <= mid and x[i] <= mid)
                {
                    if (x0 % 2 != x[i] % 2) flag = false;
                }
                else if (x0 <= mid and mid < x[i])
                {
                    if (x0 % 2 != mid % 2) flag = false;
                }
                else if (x[i] <= mid and mid < x0)
                {
                    if (x[i] % 2 != mid % 2) flag = false;
                }
            }
        }
        if (flag) l = mid;
        else r = mid;
    }
    cout << l << endl;

    return 0;
}
