#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#define MAX_N 10
using namespace std;

int n, m;
pair <long long, long long> points[MAX_N];
vector<long long> lines;
pair<int, int> parameters[MAX_N];

int main()
{
    cin >> n >> m;

    bool found;
    int y1;
    for(int i=0; i<n; i++)
    {
        cin >> points[i].first >> points[i].second;
        if(points[i].second<y1)
        {
            y1=points[i].second;
        }
        found=false;
        for(int j=0; j<lines.size(); j++)
        {
            if(lines[j]==points[i].first)
            {
                found=true;
            }
        }
        if(!found)
        {
            lines.push_back(points[i].first);
        }
    }

    sort(lines.begin(), lines.end());

    for(int i=0; i<lines.size(); i++)
    {
        parameters[i].first = INT_MAX;
        parameters[i].second = 0;

        for(int j=0; j<n; j++)
        {
            if(points[j].first==lines[i])
            {
                if(parameters[i].first>points[j].second)
                {
                    parameters[i].first=points[j].second;
                }
                if(parameters[i].second<points[j].second)
                {
                    parameters[i].second=points[j].second;
                }
            }
        }
        if(parameters[i].first==parameters[i].second)
        {
            parameters[i].first=y1;
        }
    }

    int l=0;

    for(int i=1; i<lines.size(); i++)
    {
       if((parameters[i-1].second-parameters[i-1].first)%2==1)
       {
           break;
       }
       else
       {
           if((lines[i]-lines[i-1])%2==0)
           {
               l=lines[i];
           }
           else
           {
               if(i<lines.size()-1 && parameters[i].second==parameters[i+1].second)
               {
                   l=lines[i]-1;
               }
               else
               {
                   l=lines[i]-1;
                   break;
               }
           }
       }
    }

    cout << l;

    return 0;
}
