#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define cerr if(false)cerr

const int MAX_N = 1e5 + 10;

int n, k, l;
int dist[MAX_N];
bool checked[MAX_N];

pair<pair<int, int>, int> ans[MAX_N];

int calc () {
    int curr = 0, currDist = 0;
    for (int i = 0; i < n; i ++) {
        ans[i].second = i;
        ans[i].first.first = 0;
        ans[i].first.second = 0;
        if (checked[i]) { ans[i].first.first = -1; continue;};
        if (curr <= i) {
            curr = i;
            currDist = 0;
        }
        while (curr + 1 < n && currDist + dist[curr] <= l && !checked[curr + 1]) {
            curr ++;
            currDist += dist[curr - 1];
        }
        ans[i].first.first += curr - i;
        if (checked[curr + 1]) ans[i].first.second += 1;
        if (!checked[curr + 1]) ans[i].first.second = 0;

        if (i < n - 1) currDist -= dist[i];
    }



    curr = n - 1;
    for (int i = n - 1; i >= 0; i --) {
        ans[i].second = i;
        if (checked[i]) continue;
        if (curr >= i) {
            curr = i;
            currDist = 0;
        }
        while (curr - 1 >= 0 && currDist + dist[curr - 1] <= l && !checked[curr - 1]) {
            curr --;
            currDist += dist[curr];
        }
        ans[i].first.first += i - curr;

        if (checked[curr - 1]) ans[i].first.second += 1;
        if (i - 1 >= 0) currDist -= dist[i - 1];
    }

    sort (ans, ans + n);

    for (int i = 0; i < n; i ++) {
        cerr << i << ") " << ans[i].first.first << " "<< ans[i].first.second << " " << ans[i].second << endl;
    }
    return ans[n - 1].second;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k >> l;

    for (int i = 0; i < n - 1; i ++) {
        cin >> dist[i];
    }

    for (int x = 0; x < k; x ++) {
        int curr = calc();
        cerr << "curr = " << curr << endl;


        checked[curr] = true;
        int i = curr, d = 0;
        while (i + 1 < n && d + dist[i] <= l) {
            d += dist[i];
            i ++;
            checked[i] = true;
        }

        i = curr; d = 0;
        while (i - 1 >= 0 && d + dist[i - 1] <= l) {
            d += dist[i - 1];
            i --;
            cerr << "Checking " << i << endl;
            checked[i] = true;
        }

    }
    cerr << endl;
    int ans = 0;
    for (int i = 0; i < n; i ++) {
        cerr << checked[i] << " ";
        if (checked[i]) ans ++;
    }
    cerr << endl;

    cout << ans << endl;
    return 0;
}
