#include<bits/stdc++.h>
using namespace std;

#define endl "\n"
#define cerr if(false)cerr

const long long MAX_N = 1e5 + 10;

long long n, k, l;
long long dist[MAX_N];

pair <int, int> precalc[MAX_N];

void pre () {
    long long curr = 0, currDist = 0;
    for (long long i = 0; i < n; i ++) {
        if (curr <= i) {
            curr = i;
            currDist = 0;
        }
        while (curr + 1 < n && currDist + dist[curr] <= l) {
            curr ++;
            currDist += dist[curr - 1];
        }
        precalc[i].second = curr;

        if (i < n - 1) currDist -= dist[i];
    }



    curr = n - 1;
    for (long long i = n - 1; i >= 0; i --) {
        if (curr >= i) {
            curr = i;
            currDist = 0;
        }
        while (curr - 1 >= 0 && currDist + dist[curr - 1] <= l) {
            curr --;
            currDist += dist[curr];
        }
        precalc[i].first = curr;

        if (i - 1 >= 0) currDist -= dist[i - 1];
    }
}


long long calc (int depth, bool checked[MAX_N]) {
    if (depth == 0) {
        int ans = 0;
        for (int i = 0; i < n; i ++) {
            if (checked[i]) ans ++;
        }
        return ans;
    }
    long long ans = 0;
    for (int i = 0; i < n; i ++) {
        if (checked[i]) continue;
        int x = -1, y = -1;
        for (int j = precalc[i].first; j <= precalc[i].second; j ++) {
            if (x == -1 && !checked[i]) x = j;
            if (x != -1 && y == -1 && !checked[i]) y = j;
            checked[j] = true;
        }
        ans = max(calc(depth - 1, checked), ans);
        for (int j = precalc[i].first; j <= precalc[i].second; j ++) {
            checked[j] = false;
        }
    }
    return ans;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k >> l;

    bool checked[MAX_N];
    for (long long i = 0; i < n - 1; i ++) {
        cin >> dist[i];
        checked[i] = false;
    }

    checked[n - 1] = false;

    pre();
    cout << calc(k, checked) << endl;
    return 0;
}

