# include <iostream>
# include <vector>
# include <algorithm>
# include <vector>
# include <tuple>
using namespace std;

const int MAX=1e6+11;
vector<tuple<int, int, int>> a;
int start[MAX];
int endings[MAX];
int ans[MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int n;
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        int l,r;
        cin>>l>>r;
        a.push_back(make_tuple(l,0,i));
        a.push_back(make_tuple(r,1,i));
    }

    sort(a.begin(),a.end());

    int c=0,br=0,pr=0;
    for(auto u: a)
    {
        int x,type,id;
        tie(x,type,id)=u;

        if(x!=c) c++;
        x=c;

        //cout<<x<<" "<<type<<" "<<id<<endl;
        if(endings[x]==0) endings[x]=endings[x-1];
        if(type==0)
        {
            br++;
            start[id]=x;
        }
        else
        {
            endings[x]++;
            br--;
            ans[id]=br+endings[x]-endings[start[id]-1];
            pr=x;
        }
    }

    for(int i=1;i<=n;i++)
    {
        cout<<ans[i]-1<<" ";
    }
    cout<<"\n";
    return 0;
}
