# include <iostream>
using namespace std;

const long long MAX=3*1e5+11;
long long a[MAX];
long long b[MAX];
long long n,m;

bool pos(long long mini)
{
    long long ans=0;
    for(int i=1;i<=n;i++)
    {
        ans=ans+(mini+a[i]-1)/a[i];
    }

    return ans<=m*n;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++) cin>>a[i];
    for(int i=1;i<=n;i++) cin>>b[i];

    long long l=1,r=1e18,ans=0;
    while(l<=r)
    {
        long long mid=(l+r)/2;
        if(pos(mid))
        {
            ans=mid;
            l=mid+1;
        }
        else r=mid-1;
    }

    cout<<ans<<"\n";
    return 0;
}
