#include <bits/stdc++.h>
using namespace std;

const int MAXN=3*1e5+1;
long long N, M;
long long a[MAXN];
long long b[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i=0; i<N; i++)
    {
        cin >> a[i];
    }

    for(int i=0; i<N; i++)
    {
        cin >> b[i];
    }
}

bool check(long long Min)
{
    long long totalDays=0;

    for(int i=0; i<N; i++)
    {
        long long Current=Min;

        if(a[i]>b[i])
        {
            if(M*a[i]>Current)
            {
                totalDays+=Current/a[i];

                if((Current/a[i])*a[i]!=Current)
                {
                    totalDays++;
                }
            }
            else
            {
                totalDays+=M;
                Current-=M*a[i];
                totalDays+=Current/b[i];

                if((Current/b[i])*b[i]!=Current)
                {
                    totalDays++;
                }
            }
        }
        else
        {
            totalDays+=Current/b[i];

            if((Current/b[i])*b[i]!=Current)
            {
                totalDays++;
            }
        }

        if(totalDays>N*M)
        {
            return false;
        }
    }

    return true;
}

void Solve()
{
    long long l=1, r=1e18;
    long long ans=-1;

    while(l<=r)
    {
        long long m=(l+r)/2;

        if(check(m))
        {
            ans=m;
            l=m+1;
        }
        else
        {
            r=m-1;
        }
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

