#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
long long N, K;
long long L;
long long d[MAXN];
int visited[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> L;

    for(int i=0; i<N-1; i++)
    {
        cin >> d[i];
    }
}

void Solve()
{
    long long ans=0;

    while(K!=0)
    {
        long long Max=0, MaxI;

        for(int i=0; i<N; i++)
        {
            if(visited[i]==1)
            {
                continue;
            }

            long long Current=1;
            long long Dist=0;

            for(int j=i-1; j>=0; j--)
            {
                Dist+=d[j];

                if(Dist>L)
                {
                    break;
                }

                if(visited[j]==1)
                {
                    continue;
                }

                Current++;
            }

            Dist=0;

            for(int j=i; j<N-1; j++)
            {
                Dist+=d[j];

                if(Dist>L)
                {
                    break;
                }

                if(visited[j]==1)
                {
                    continue;
                }

                Current++;
            }

            if(Current>Max)
            {
                Max=Current;
                MaxI=i;
            }
        }

        visited[MaxI]=1;

        long long Dist=0;

        for(int j=MaxI-1; j>=0; j--)
        {
            Dist+=d[j];

            if(Dist>L)
            {
                break;
            }

            visited[j]=1;
        }

        Dist=0;

        for(int j=MaxI; j<N-1; j++)
        {
            Dist+=d[j];

            if(Dist>L)
            {
                break;
            }

            visited[j]=1;
        }

        ans+=Max;
        K--;
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

