#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
long long N, K;
long long L;
long long d[MAXN];
long long prefix[MAXN];
vector<pair<int, int>> intervals;
int Visited[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> L;

    for(int i=0; i<N-1; i++)
    {
        cin >> d[i];
    }

    for(int i=1; i<N; i++)
    {
        prefix[i]=prefix[i-1]+d[i-1];
    }
}

void Solve()
{
    for(int i=0; i<N; i++)
    {
        int l=i, r=i;

        for(int j=i-1; j>=0; j--)
        {
            if(prefix[i]-prefix[j]<=L)
            {
                l=j;
            }
            else
            {
                break;
            }
        }

        for(int j=i+1; j<N; j++)
        {
            if(prefix[j]-prefix[i]<=L)
            {
                ///cout << i << " ";
                r=j;
            }
            else
            {
                break;
            }
        }

        intervals.push_back({l, r});
        ///cout << l << " " << r << '\n';
    }

    long long ans=0;

    while(K!=0)
    {
        long long Max=0, MaxI;

        for(int i=0; i<N; i++)
        {
            long long Current=0;

            for(int l=intervals[i].first; l<=intervals[i].second; l++)
            {
                if(Visited[l]==0)
                {
                    Current++;
                }
            }

            if(Current>Max)
            {
                Max=Current;
                MaxI=i;
            }
        }

        for(int l=intervals[MaxI].first; l<=intervals[MaxI].second; l++)
        {
            Visited[l]=1;
        }

        ans+=Max;
        K--;
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

