#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
unsigned long long N, K;
unsigned long long L;
unsigned long long d[MAXN];
int visited[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> L;

    for(int i=0; i<N-1; i++)
    {
        cin >> d[i];
    }
}

void Solve()
{
    unsigned long long ans=0;

    while(K!=0)
    {
        unsigned long long Max=0, MaxI;

        for(int i=0; i<N; i++)
        {
            unsigned long long Current=1;
            unsigned long long Dist=0;

            if(visited[i]==1)
            {
                Current=0;
            }

            for(int j=i-1; j>=0; j--)
            {
                Dist+=d[j];

                if(Dist>L)
                {
                    break;
                }

                if(visited[j]==0)
                {
                    Current++;
                }
            }

            Dist=0;

            for(int j=i; j<N-1; j++)
            {
                Dist+=d[j];

                if(Dist>L)
                {
                    break;
                }

                if(visited[j+1]==0)
                {
                    Current++;
                }
            }

            if(Current>Max)
            {
                Max=Current;
                MaxI=i;
            }
        }

        if(Max==0)
        {
            break;
        }

        visited[MaxI]=1;

        unsigned long long Dist=0;

        for(int j=MaxI-1; j>=0; j--)
        {
            Dist+=d[j];

            if(Dist>L)
            {
                break;
            }

            visited[j]=1;
        }

        Dist=0;

        for(int j=MaxI; j<N-1; j++)
        {
            Dist+=d[j];

            if(Dist>L)
            {
                break;
            }

            visited[j+1]=1;
        }

        ans+=Max;
        if(ans==N)
        {
            break;
        }
        K--;
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

