#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N, K;
bool Visited[MAXN];
long L;
long d[MAXN];
long long prefix[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> L;

    for(int i=0; i<N-1; i++)
    {
        cin >> d[i];
    }

    for(int i=1; i<N; i++)
    {
        prefix[i]=prefix[i-1]+d[i-1];
    }
}

void Solve()
{
    long long ans=0;

    while(K>0)
    {
        long long Max=0, MaxI;

        for(int i=0; i<N; i++)
        {
            if(Visited[i])
            {
                continue;
            }

            long long Current=1;

            for(int j=i-1; j>=0; j--)
            {
                if(prefix[i]-prefix[j]>L)
                {
                    break;
                }

                if(Visited[j])
                {
                    continue;
                }

                Current++;
            }

            for(int j=i+1; j<N; j++)
            {
                if(prefix[j]-prefix[i]>L)
                {
                    break;
                }

                if(Visited[j])
                {
                    continue;
                }

                Current++;
            }

            if(Max<Current)
            {
                Max=Current;
                MaxI=i;
            }
        }

        if(Max==0)
        {
            break;
        }

        for(int j=MaxI-1; j>=0; j--)
        {
            if(prefix[MaxI]-prefix[j]>L)
            {
                break;
            }

            Visited[j]=true;
        }

        for(int j=MaxI+1; j<N; j++)
        {
            if(prefix[j]-prefix[MaxI]>L)
            {
                break;
            }

            Visited[j]=true;
        }


        ans+=Max;
        K--;
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

