#include <bits/stdc++.h>
using namespace std;

long long d[100000];
int left_idx[100001], right_idx[100001];

int dp[100001][501];
bool visited[100001][501];

int f(int n, int k) {
    if (n <= 0 || k <= 0) return 0;

    if (visited[n][k]) return dp[n][k];
    visited[n][k] = 1;

    int optimal_left = left_idx[n];
    optimal_left = left_idx[optimal_left];

    return dp[n][k] = max(f(n - 1, k), f(optimal_left, k - 1) + n - optimal_left + 1);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, k, l;
    cin >> n >> k >> l;

    for (int i = 1; i <= n - 1; i++) {
        cin >> d[i];
        d[i] += d[i - 1];
    }

    for (int i = 1; i <= n; i++) {
        auto left_it = lower_bound(d, d + n + 1, d[i - 1] - l);
        auto right_it = upper_bound(d, d + n + 1, d[i - 1] + l) - 1;

        left_idx[i] = max(1, (int) (left_it - d) + 1);
        right_idx[i] = min((int) n, (int) (right_it - d) + 1);
    }

    //for (int i = 1; i <= n; i++) cout << left_idx[i] << ' ' << right_idx[i] << endl;

    cout << f(n, k) << endl;
    return 0;

}

