#include <iostream>
#include <algorithm>
using namespace std;
#define st first.first
#define e first.second
#define id second

pair<pair<int, int>, int> proj[1000005];
pair<bool, int> event[20000009];
int ans[1000005];
int stTime[1000005];
int projStTimeIdx[1000005];

bool customSort(pair<bool, int> a, pair<bool, int> b) {
    if ((a.first ? proj[a.second].st : proj[a.second].e) > (b.first ? proj[b.second].st : proj[b.second].e)) {
        return 0;
    }
    if ((a.first ? proj[a.second].st : proj[a.second].e) == (b.first ? proj[b.second].st : proj[b.second].e)) {
        if (a.first < b.first) {
            return 0;
        } else {
            if (a.first == b.first) {
                if (a.second > b.second) {
                    return 0;
                } else {
                    return 1;
                }
            }
            return 1;
        }
    }
    return 1;
}

int bin_search(int n, int x) {
    int l = -1, r = n;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (stTime[mid] == x) {
            l = mid;
            continue;
        }
        if (stTime[mid] <= x) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> proj[i].st >> proj[i].e;
        proj[i].id = i;
        event[i * 2] = make_pair(true, i);
        event[i * 2 + 1] = make_pair(false, i);
    }

    sort(event, event + 2 * n, customSort);
    int curOpen = 0, curStarted = 0;;
    for (int i = 0; i < 2 * n; i++) {
        if (event[i].first) {
            ans[event[i].second] += curOpen;
            curOpen++;
            stTime[curStarted] = proj[event[i].second].st;
            projStTimeIdx[event[i].second] = curStarted;
            curStarted++;
        } else {
            curOpen--;
        }
    }

//    for (int i = 0; i < 2 * n; i++) {
//        cout << event[i].first << " " << event[i].second << " " << (event[i].first ? proj[event[i].second].st : proj[event[i].second].e) << "\n";
//    }

    for (int i = 0; i < n; i++) {
//        cout << ans[i] << " " << bin_search(n, proj[i].e) << " " << projStTimeIdx[i] << " ";
        ans[i] += bin_search(n, proj[i].e) - projStTimeIdx[i] - 1;
        cout << ans[i] << " ";
//        cout << ans[i] << "\n";
    }
}
