#include <iostream>
#include <queue>
using namespace std;
#define ll long long

priority_queue<pair<ll, ll>> pq;

ll a[300005];
ll b[300005];

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m;
    cin >> n >> m;

    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pq.push(make_pair(0, i));
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
    }


    for (ll j = 0; j < m; j++) {
        for (ll i = 0; i < n; i++) {
            ll x = pq.top().first;
            if (pq.top().second == i && a[i] > b[i]) {
                x -= a[i];
            } else {
                x -= b[pq.top().second];
            }
            ll id = pq.top().second;
            pq.pop();
            pq.push(make_pair(x, id));
        }
    }
    cout << -(pq.top().first);
}
