#include <iostream>
#include <algorithm>
#include <queue>
using namespace std;
#define ll long long

priority_queue<pair<ll, ll>> pq;

pair<ll, ll> s[300005];

ll lUsed[300005];
ll pts[300005];

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m;
    cin >> n >> m;

    for (ll i = 0; i < n; i++) {
        cin >> s[i].first;
    }
    for (ll i = 0; i < n; i++) {
        cin >> s[i].second;
        if (s[i].second > s[i].first) {
            s[i].first = s[i].second;
        }
    }

    sort(s, s + n);

    lUsed[0] = m;
    pts[0] = m * s[0].first;
    pq.push(make_pair(-pts[0], 0));
    ll fl = m * (n - 1);

    for (ll i = 1; i < n; i++) {
        pts[i] = s[i].first * (pts[0] / s[i].first + (pts[0] % s[i].first != 0));
        fl -= pts[0] / s[i].first + (pts[0] % s[i].first != 0);
        lUsed[i] += pts[0] / s[i].first + (pts[0] % s[i].first != 0);
        pq.push(make_pair(-pts[i], i));
//        cout << pts[i] << " " << s[i].first << " " << s[i].second << " " << pts[0] / s[i].first + (pts[0] % s[i].first != 0) << "\n";
    }

    for (ll i = 0; i < fl; i++) {
        ll x = -pq.top().first;
        ll id = pq.top().second;
        if (lUsed[id] >= m) {
            x += s[id].second;
        } else {
            lUsed[id]++;
            x += s[id].first;
        }
        pq.pop();
        pq.push(make_pair(-x, id));
    }
    cout << -pq.top().first;
}
