#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct node{
    int blocks;
    long long pref,suff;
    long long sumodd,sumeven;
};

int n,q,d[MAXN],type,pos,l,r;
long long s;

node tree[4*MAXN],curr;

node combine(node fr,node sc,int pos){
    if(fr.blocks==-1)return sc;
    if(sc.blocks==-1)return fr;

    node res={0,0,0,0,0};

    if(d[pos]==0){
        res.blocks=fr.blocks+sc.blocks;

        if(fr.blocks>0)res.pref=fr.pref;
        else res.pref=max(fr.pref,sc.pref);

        if(sc.blocks>0)res.suff=sc.suff;
        else res.suff=max(fr.suff,sc.suff);

        if(fr.blocks%2==0){
            res.sumodd=fr.sumodd+sc.sumodd;

            if(fr.blocks>0 and sc.blocks>0)res.sumeven=fr.sumeven+max(fr.suff,sc.pref)+sc.sumeven;
            else res.sumeven=fr.sumeven+sc.sumeven;
        }else{
            res.sumeven=fr.sumeven+sc.sumodd;

            if(sc.blocks>0)res.sumodd=fr.sumodd+max(fr.suff,sc.pref)+sc.sumeven;
            else res.sumodd=fr.sumodd;
        }
    }else{
        res.blocks=fr.blocks+sc.blocks+1;

        res.pref=fr.pref;
        res.suff=sc.suff;

        if(fr.blocks%2==0){
            if(fr.blocks>0)res.sumeven=fr.sumeven+fr.suff+sc.sumodd;
            else res.sumeven=sc.sumodd;

            if(sc.blocks>0)res.sumodd=fr.sumodd+sc.pref+sc.sumeven;
            else res.sumodd=fr.sumodd;
        }else{
            if(sc.blocks>0)res.sumeven=fr.sumeven+sc.pref+sc.sumeven;
            else res.sumeven=fr.sumeven;

            res.sumodd=fr.sumodd+fr.suff+sc.sumodd;
        }
    }

    return res;
}

void update(int v,int l,int r,int pos,int val){
    if(l==r){
        d[l]=val;
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos,val);
        else update(2*v+1,tt+1,r,pos,val);

        tree[v]=combine(tree[2*v],tree[2*v+1],tt);
    }
}

void upgrade(int v,int l,int r,int pos,long long val){
    if(l==r){
        tree[v].pref+=val;
        tree[v].suff+=val;
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)upgrade(2*v,l,tt,pos,val);
        else upgrade(2*v+1,tt+1,r,pos,val);

        tree[v]=combine(tree[2*v],tree[2*v+1],tt);
    }
}

node getinfo(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {-1,0,0,0,0};

    if(l==ll and r==rr){
        return tree[v];
    }else{
        int tt=(l+r)/2;
        return combine( getinfo(2*v,l,tt,ll,min(tt,rr)) , getinfo(2*v+1,tt+1,r,max(tt+1,ll),rr) , tt );
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=q;i++){
        cin>>type;
        if(type==1){
            cin>>pos;
            update(1,1,n,pos,1);
        }else if(type==2){
            cin>>pos;
            update(1,1,n,pos,0);
        }else if(type==3){
            cin>>pos>>s;
            upgrade(1,1,n,pos,s);
        }else{
            cin>>l>>r;
            curr=getinfo(1,1,n,l,r);

            if(curr.blocks>0)curr.sumeven+=curr.pref;
            if(curr.blocks%2==0 and curr.blocks>0)curr.sumeven+=curr.suff;
            if(curr.blocks%2==1)curr.sumodd+=curr.suff;

            if(getinfo(1,1,n,1,l).blocks%2==0)cout<<curr.sumodd<<"\n";
            else cout<<curr.sumeven<<"\n";
        }
    }

    return 0;
}

