#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const int inf=1e9;

struct event{
    int pos;
    int from,to;
};

struct node{
    int l,r;
    int cnt0,cnt1,cnt2;
}curr;

int n,m,x[MAXN],y[MAXN],cnt,num;
vector<event> v;

bool cmp(event fr,event sc){
    return fr.pos<sc.pos;
}

int last[MAXN],ans,r,good;
node tree[40*MAXN];
int lazy[40*MAXN];

bool ok(node s){
    return s.cnt0+s.cnt1==0 or s.cnt0+s.cnt2==0 or s.cnt1+s.cnt2==0;
}

void psh(int v,int l,int r){
    int tt=(l+r)/2;

    if(tree[v].l==0){
        num++; tree[v].l=num;
        tree[num].cnt2=(tt-l+1);
    }

    if(tree[v].r==0){
        num++; tree[v].r=num;
        tree[num].cnt2=(r-(tt+1)+1);
    }

    if(lazy[v]==-2)return;

    if(lazy[v]==0){
        tree[tree[v].l].cnt0=(tt-l+1);
        tree[tree[v].r].cnt0=(r-(tt+1)+1);

        tree[tree[v].l].cnt1=tree[tree[v].r].cnt1=0;
        tree[tree[v].l].cnt2=tree[tree[v].r].cnt2=0;

        lazy[tree[v].l]=0; lazy[tree[v].r]=0;
        lazy[v]=-2;
    }

    if(lazy[v]==1){
        tree[tree[v].l].cnt1=(tt-l+1);
        tree[tree[v].r].cnt1=(r-(tt+1)+1);

        tree[tree[v].l].cnt0=tree[tree[v].r].cnt0=0;
        tree[tree[v].l].cnt2=tree[tree[v].r].cnt2=0;

        lazy[tree[v].l]=0; lazy[tree[v].r]=0;
        lazy[v]=-2;
    }

    if(lazy[v]==-1){
        tree[tree[v].l].cnt2=(tt-l+1);
        tree[tree[v].r].cnt2=(r-(tt+1)+1);

        tree[tree[v].l].cnt1=tree[tree[v].r].cnt1=0;
        tree[tree[v].l].cnt0=tree[tree[v].r].cnt0=0;

        lazy[tree[v].l]=0; lazy[tree[v].r]=0;
        lazy[v]=-2;
    }
}

void flip(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;

    if(l==ll and r==rr and ok(tree[v])){
        if(tree[v].cnt2>0){
            tree[v].cnt2=0;

            if(val==0)tree[v].cnt0=r-l+1;
            else tree[v].cnt1=r-l+1;

            lazy[v]=val;
        }else{
            tree[v].cnt0=tree[v].cnt1=0;
            tree[v].cnt2=r-l+1;
            lazy[v]=-1;
        }
    }else{
        psh(v,l,r);
        int tt=(l+r)/2;

        flip(tree[v].l,l,tt,ll,min(tt,rr),val);
        flip(tree[v].r,tt+1,r,max(tt+1,ll),rr,val);

        tree[v].cnt0=tree[tree[v].l].cnt0+tree[tree[v].r].cnt0;
        tree[v].cnt1=tree[tree[v].l].cnt1+tree[tree[v].r].cnt1;
        tree[v].cnt2=tree[tree[v].l].cnt2+tree[tree[v].r].cnt2;
    }
}

node combine(node fr,node sc){
    return {0,0,fr.cnt0+sc.cnt0,fr.cnt1+sc.cnt1,fr.cnt2+sc.cnt2};
}

node getinfo(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0,0,0,0};

    if(l==ll and r==rr){
        return tree[v];
    }else{
        psh(v,l,r);
        int tt=(l+r)/2;

        return combine( getinfo(tree[v].l,l,tt,ll,min(tt,rr)) , getinfo(tree[v].r,tt+1,r,max(tt+1,ll),rr) );
    }
}

void prnt(){
    cout<<good<<"\n";
    exit(0);
}


int main(){

    //ios_base::sync_with_stdio(0);
   // cin.tie(0);
    //cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>x[i]>>y[i];
    }

    for(int i=2;i<=n;i++){
        if(x[i]==x[i-1]){
            v.push_back({x[i],min(y[i-1],y[i]),max(y[i-1],y[i])-1});
        }
    }

    if(x[1]==x[n]){
        v.push_back({x[n],min(y[1],y[n]),max(y[1],y[n])-1});
    }

    sort(v.begin(),v.end(),cmp);

    tree[1].cnt2=inf;
    num=1;

    for(int i=0;i<=40*200000;i++)lazy[i]=-2;
    
    for(int i=0;i<=1001;i++)last[i]=-1;

    for(int i=0;i<v.size();i++){
        curr=getinfo(1,0,inf,v[i].from,v[i].to);

        //if(v[i].pos%2==0 and curr.cnt1>0)prnt();
        //if(v[i].pos%2==1 and curr.cnt0>0)prnt();

        flip(1,0,inf,v[i].from,v[i].to,v[i].pos%2);
        
         for(int f=v[i].from;f<=v[i].to;f++){
            if(last[f]==-1)last[f]=v[i].pos;
            else{
                if((v[i].pos-last[f])%2!=0)prnt();
                last[f]=-1;
            }
        }

        if(i<v.size() and v[i].pos!=v[i+1].pos){
            cnt=0; r=0;
            for(int f=0;f<=1001;f++){
                if(last[f]!=-1 and last[f]%2==0){
                    r=last[f]; cnt++;
                }else{
                    if(cnt%2==1)prnt();
                    cnt=0;
                }

            }

            cnt=0;
            for(int f=0;f<=1001;f++){
                if(last[f]!=-1 and last[f]%2==1){
                    r=last[f]; cnt++;
                }else{
                    if(cnt%2==1)prnt();
                    cnt=0;
                }
            }

            for(int f=0;f<=1001;f++){
                if(last[f]!=-1 and last[f]%2!=r%2)break;
                else if(f==1001){
                    if(r%2==0)good={v[i+1].pos-v[i+1].pos%2};
                    else {good=v[i+1].pos-(1-v[i+1].pos%2);}
                }
            }
        }
    }

    cout<<m<<"\n";

    return 0;
}

