#include "zeroes.h"
#include <bits/stdc++.h>

using namespace std;

bool solve(int n, int call)
{
    srand(time(NULL));

    const int times = min(n, 120);

    bool row0[n] = {};
    bool col0[n] = {};

    for (int row = 0; row < n; ++row)
    {
        bool checked[n] = {};
        int curr = 0;

        while (curr < times)
        {
            int col = rand() % n;
            curr += (1 - checked[col]);

            if (checked[col] == false && get_mem(row, col) == 0)
            {
                col0[col] = true;
                row0[row] = true;
                checked[col] = true;
                break;
            }
        }
    }

    for (int col = 0; col < n; ++col)
    {
        bool checked[n] = {};

        if (col0[col] == false)
        {
            int curr = 0;

            while (curr < times)
            {
                int row = rand() % n;
                curr += (1 - checked[row]);

                if (checked[row] == false && get_mem(row, col) == 0)
                {
                    col0[col] = true;
                    row0[row] = true;
                    checked[row] = true;
                    break;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            if (row0[i] == 1 || col0[j] == 1)
            {
                set_mem(i, j, 0);
            }
        }
    }

    return true;
}
