#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n, m;

struct Point
{
    int x, y;
};

Point a[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i].x >> a[i].y;
    }

    vector<pair<int, pair<int, int>>> v;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            if (a[i].x == a[j].x)
            {
                v.push_back(make_pair(a[i].x, make_pair(a[i].y, a[j].y)));
            }
        }
    }

    sort(v.begin(), v.end());

    for (int i = 0; i < v.size(); ++i)
    {
        if (abs(v[i].second.first - v[i].second.second) % 2 == 1)
        {
            cout << 0 << endl;
            return 0;
        }
    }

    int ans = 0;

    for (int i = 1; i < v.size(); ++i)
    {
        int res = v[i].first;

        if (v[i - 1].first % 2 != res % 2)
        {
            --res;
        }

        bool flag = false;

        for (int j = i - 2; j >= 0; --j)
        {
            if (res % 2 != v[j].first % 2)
            {
                flag = true;
                break;
            }
        }

        if (flag == false)
        {
            ans = max(ans, res);
            break;
        }
    }

    cout << ans << endl;

    return 0;
}

/*
4 10
5 8
10 8
10 4
5 4
*/
