#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const int inf = 1000000007;

int n, m;

struct Point
{
    int x, y;
};

Point a[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i].x >> a[i].y;
    }

    vector<pair<int, pair<int, int>>> v;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= n; ++j)
        {
            if (a[i].x == a[j].x)
            {
                v.push_back(make_pair(a[i].x, make_pair(a[i].y, a[j].y)));
            }
        }
    }

    sort(v.begin(), v.end());

    bool is4 = false;

    for (int i = 0; i < v.size(); ++i)
    {
        for (int j = i + 1; j < v.size(); ++j)
        {
            if (v[i].first == v[j].first)
            {
                is4 = true;
                break;
            }
        }
    }

    if (is4 == true)
    {
        int x1 = inf + 5;
        int y1 = inf + 5;
        int x2 = 0;
        int y2 = 0;

        for (int i = 1; i <= n; ++i)
        {
            x1 = min(x1, a[i].x);
            x2 = max(x2, a[i].x);
            y1 = min(y1, a[i].y);
            y2 = max(y2, a[i].y);
        }

        if ((y2 - y1) % 2 == 1)
        {
            cout << 0 << endl;
        }
        else
        {
            cout << (x2 - x1) - (x2 - x1) % 2 << endl;
        }

        return 0;
    }

    int ans = 0;

    for (int i = 1; i < v.size(); ++i)
    {
        int res = v[i].first;

        if (v[i - 1].first % 2 != res % 2)
        {
            --res;
        }

        if (res < 0)
        {
            continue;
        }

        //cout << i << " :: " << res << endl;

        bool flag = false;

        for (int j = i - 1; j >= 0; --j)
        {
            if (res % 2 != v[j].first % 2 || abs(v[j].second.second - v[j].second.first) % 2 == 1)
            {
                flag = true;
                break;
            }
        }

        if (flag == false)
        {
            ans = max(ans, res);
        }
    }

    cout << ans << endl;

    return 0;
}

/*
4 10
5 8
10 8
10 4
5 4

6 4
5 0
5 2
3 2
3 4
0 4
0 0

6 2
5 0
5 1
3 1
3 2
0 2
0 0

6 4
0 0
0 2
2 2
2 5
5 5
5 0

6 2
2 2
2 1
2 0
0 0
0 1
0 2
*/
