#include<iostream>
#define endl '\n'
using namespace std;
long long maxi[400005][2];
bool pos[400005];
void updateshift(long long node,long long l,long long r,long long le)
{
    if(l>=le)
    {
        pos[node]=!pos[node];
        return;
    }
    if(l>r || r<le) return;

    long long mid=(l+r)/2;
    updateshift(2*node,l,mid,le);
    updateshift(2*node+1,mid+1,r,le);
}
void updateval(long long node,long long l,long long r,long long p,long long a,bool switches)
{
    if(pos[node])
    {
        switches=!switches;
    }
    if(l>p || r<p) return;
    if(l==r)
    {
        maxi[node][switches]+=a;
        return;
    }


    long long mid=(l+r)/2;

    updateval(2*node,l,mid,p,a,switches);
    updateval(2*node+1,mid+1,r,p,a,switches);

  //  maxi[node][0]=max(maxi[2*node][0],maxi[2*node+1][0]);
   // maxi[node][1]=max(maxi[2*node][1],maxi[2*node+1][1]);
}
long long query(long long node,long long l,long long r,long long le,long long ri,bool switches)
{
    if(pos[node])
    {
       switches=!switches;
    }
    if(l>ri || r<le) return 0;

    if(l==le && r==ri)
    {
        return maxi[node][switches];
    }
    long long mid=(l+r)/2,r1=0,r2=0;

    r1=query(2*node,l,mid,le,ri,switches);
    r2=query(2*node+1,mid+1,r,le,ri,switches);

   // maxi[node][0]=max(maxi[2*node][0],maxi[2*node+1][0]);
   // maxi[node][1]=max(maxi[2*node][1],maxi[2*node+1][1]);

    return max(r1,r2);
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,q,type,p,c;
    cin>>n>>q;

    while(q--)
    {
        cin>>type;

        if(type==1 || type==2)
        {
           cin>>p;
           p++;
           updateshift(1,1,n,p);
           continue;
        }
        if(type==3)
        {
            cin>>c>>p;
            updateval(1,1,n,c,p,0);
            continue;
        }
        cin>>c>>p;
        cout<<query(1,1,n,c,p,0)<<endl;
    }

}
/*
10 11
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 2 2
4 3 3
4 4 4
4 5 5
4 6 6
4 7 7
*/
