#include<iostream>
#define endl '\n'
using namespace std;
long long maxi[400005];
bool isch[100005];
long long ind=0;
pair<long long,long long> d[100005];
void updateshift(long long node,long long l,long long r,long long le)
{
    if(l>=le)
    {
        return;
    }
    if(l>r || r<le) return;

    long long mid=(l+r)/2;
    updateshift(2*node,l,mid,le);
    updateshift(2*node+1,mid+1,r,le);
}
void updateval(long long node,long long l,long long r,long long p,long long a)
{
    if(l>p || r<p) return;
    if(l==r)
    {
        maxi[node]+=a;
        return;
    }
    long long mid=(l+r)/2;

    updateval(2*node,l,mid,p,a);
    updateval(2*node+1,mid+1,r,p,a);

     maxi[node]=max(maxi[2*node],maxi[2*node+1]);

    if(!isch[mid] && !isch[mid+1])
    maxi[node]= max(maxi[2*node],maxi[2*node+1]);

    else maxi[node]=maxi[2*node]+maxi[2*node+1];
   // maxi[node][1]=max(maxi[2*node][1],maxi[2*node+1][1]);
}
long long query(long long node,long long l,long long r,long long le,long long ri)
{
    if(l>ri || r<le) return 0;

    if(l==r)
    {
        return maxi[node];
    }
    long long mid=(l+r)/2,r1=0,r2=0;

    r1=query(2*node,l,mid,le,ri);
    r2=query(2*node+1,mid+1,r,le,ri);

   // maxi[node][0]=max(maxi[2*node][0],maxi[2*node+1][0]);
   // maxi[node][1]=max(maxi[2*node][1],maxi[2*node+1][1]);

   if(!isch[mid] && !isch[mid+1])
    return max(r1,r2);

    return r1+r2;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,q,type,p,c;
    cin>>n>>q;

    while(q--)
    {
        cin>>type;

        if(type==1 || type==2)
        {
           cin>>p;
           p++;
           isch[p]=!isch[p];
           continue;
        }
        if(type==3)
        {
            cin>>c>>p;
            ind++;
            d[ind]={c,p};
            continue;
        }
        else
        {
            for(int i=1;i<=n;i++)
            {
                isch[i]=isch[i-1]^isch[i];
            }
             for(int i=1;i<=n;i++)
            {
                isch[i]=!isch[i];
            }

            for(int i=1;i<=ind;i++)
            {
                if(!isch[d[i].first])
                {
                    updateval(1,1,n,d[i].first,d[i].second);
                }

            }
            cin>>c>>p;
            cout<<query(1,1,n,c,p)<<endl;
            break;
        }
    }
    while(q--)
    {
        cin>>type>>c>>p;
        cout<<query(1,1,n,c,p)<<endl;
    }

}
/*
10 18
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 2 2
4 3 3
4 4 4
4 5 5
4 6 6
4 7 7
1 3
4 2 2
4 3 3
4 4 4
4 5 5
4 6 6


10 7
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 6
4 5 7
*/
