#include<iostream>
using namespace std;
pair<int,int> group[100007];
long long vh[100007];
void update(int ind,int l,int r,int ql,int qr,int val){
    if(ql<=l and r<=qr){
        group[ind].first+=val;
        group[ind].second+=val;
    }else{
        int m = (l+r)/2;
        if(ql<=m){
            update(2*ind,l,m,ql,qr,val);
        }if(qr>m) update(2*ind+1,m+1,r,ql,qr,val);
        group[ind].first=group[2*ind].first;
        group[ind].second=group[2*ind].second;
    }
}
int find_group(int ind,int l,int r,int ql){
    if(group[ind].first==group[ind].second and ql>=l){
        return group[ind].first;
    }else{
        int m = (l+r)/2;
        if(ql<=m) return find_group(2*ind,l,m,ql);
        else return find_group(2*ind+1,m+1,r,ql);
    }
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long n,q;
    cin>>n>>q;
    long long type,a,b;
    while(q--){
        cin>>type;
        if(type==1){
            cin>>a;
            update(1,1,n,a,n,1);
        }
        if(type==2){
            cin>>a;
            update(1,1,n,a,n,-1);
        }
        if(type==3){
            cin>>a>>b;
            vh[a]+=b;
        }
        if(type==4){
            cin>>a>>b;
            if(a==b){
                int c = find_group(1,1,n,a);
                if(c%2==1) cout<<vh[a]<<"\n";
                else cout<<0<<"\n";
            }/*else{
                long long sum = 0 ;
                long long currmax = 0;
                for(long long i=a;i<=b;i++){
                    if(group[i]%2==1){
                        currmax = max(currmax,vh[i]);
                    }else{
                        if(i>0 and group[i-1]%2==1){
                            sum+=currmax;
                            currmax=0;
                        }
                    }
                }
                sum+=currmax;
                cout<<sum<<"\n";
            }*/

        }
    }


    return 0;
}
