#include<bits/stdc++.h>
using namespace std;
#define MAXN 100007
struct node
{
    bool lazy;
    int leftlen[2],rightlen[2];
    long long leftmks[2],rightmks[2];
    long long midsum[2];
    int len;
    int ll,rr;
    void reset()
    {
        len=0;
        ll=0;
        rr=0;
        lazy=false;
        leftlen[0]=0;
        leftlen[1]=0;
        rightlen[1]=0;
        rightlen[0]=0;
        leftmks[1]=0;
        leftmks[0]=0;
        rightmks[0]=0;
        rightmks[1]=0;
        midsum[0]=0;
        midsum[1]=0;
    }
} seg[4*MAXN];
int n,qq;
void Push(int ind)
{
    if (!seg[ind].lazy) return;
    seg[ind].lazy=false;
    swap(seg[ind].leftlen[0],seg[ind].leftlen[1]);
    swap(seg[ind].rightlen[0],seg[ind].rightlen[1]);
    swap(seg[ind].rightmks[0],seg[ind].rightmks[1]);
    swap(seg[ind].leftmks[0],seg[ind].leftmks[1]);
    swap(seg[ind].midsum[0],seg[ind].midsum[1]);
    if (seg[ind].ll!=seg[ind].rr)
    {
        //Push(ind*2);
        //Push(ind*2+1);
        seg[ind*2].lazy=!seg[ind*2].lazy;
        seg[ind*2+1].lazy=!seg[ind*2+1].lazy;
    }
}
void MakeRight(int ind)
{
    Push(ind);
    Push(ind*2);
    Push(ind*2+1);
    seg[ind].ll=seg[ind*2].ll;
    seg[ind].rr=seg[ind*2+1].rr;
    seg[ind].len=seg[ind*2].len+seg[ind*2+1].len;
    for (int aa=0;aa<=1;aa++)
    {
        seg[ind].midsum[aa]=seg[ind*2].midsum[aa]+seg[ind*2+1].midsum[aa];
        seg[ind].rightlen[aa]=seg[ind*2+1].rightlen[aa];
        if (seg[ind*2+1].rightlen[aa]==seg[ind*2+1].len) seg[ind].rightlen[aa]+=seg[ind*2].rightlen[aa];
        seg[ind].rightmks[aa]=seg[ind*2+1].rightmks[aa];
        if (seg[ind*2+1].rightlen[aa]==seg[ind*2+1].len) seg[ind].rightmks[aa]=max(seg[ind].rightmks[aa],seg[ind*2].rightmks[aa]);
        seg[ind].leftmks[aa]=seg[ind*2].leftmks[aa];
        if (seg[ind*2].leftlen[aa]==seg[ind*2].len) seg[ind].leftmks[aa]=max(seg[ind].leftmks[aa],seg[ind*2+1].leftmks[aa]);
        seg[ind].leftlen[aa]=seg[ind*2].leftlen[aa];
        if (seg[ind*2].leftlen[aa]==seg[ind*2].len) seg[ind].leftlen[aa]+=seg[ind*2+1].leftlen[aa];
        //int nlen=seg[ind*2].rightlen+seg[ind*2+1].leftlen;
        long long nmks=max(seg[ind*2].rightmks[aa],seg[ind*2+1].leftmks[aa]);
        if (seg[ind*2+1].leftlen[aa]==seg[ind*2+1].len || seg[ind*2].rightlen[aa]==seg[ind*2].len)
        {

        }
        else seg[ind].midsum[aa]+=nmks;
    }
}
void Initialise(int ind, int l, int r)
{
    seg[ind].lazy=false;
    if (l==r)
    {
        seg[ind].leftlen[1]=0;
        seg[ind].rightlen[1]=0;
        seg[ind].leftmks[1]=0;
        seg[ind].rightmks[1]=0;
        seg[ind].midsum[1]=0;
        seg[ind].ll=l;
        seg[ind].rr=r;
        seg[ind].len=r-l+1;
        seg[ind].leftlen[0]=1;
        seg[ind].rightlen[0]=1;
        seg[ind].leftmks[0]=0;
        seg[ind].rightmks[0]=0;
        seg[ind].midsum[0]=0;
        return;
    }
    int mid=(l+r)/2;
    Initialise(ind*2,l,mid);
    Initialise(ind*2+1,mid+1,r);
    MakeRight(ind);
}
void Update(int ind, int l, int r, int pos, long long ch)
{
    Push(ind);
    if (l==r && l==pos)
    {
        if (seg[ind].leftlen[0]==1)
        {
            seg[ind].leftmks[0]+=ch;
            seg[ind].rightmks[0]+=ch;
        }
        else
        {
            seg[ind].leftmks[1]+=ch;
            seg[ind].rightmks[1]+=ch;
        }
        //cout<<seg[ind].leftlen[1]<<" "<<seg[ind].leftmks[1]<<" "<<seg[ind].rightlen[1]<<" "<<seg[ind].rightmks[1]<<"\n";
        //cout<<seg[ind].leftlen[0]<<" "<<seg[ind].leftmks[0]<<" "<<seg[ind].rightlen[0]<<" "<<seg[ind].rightmks[0]<<"\n";
        return;
    }
    int mid=(l+r)/2;
    if (pos<=mid) Update(ind*2,l,mid,pos,ch);
    if (pos>=mid+1) Update(ind*2+1,mid+1,r,pos,ch);
    MakeRight(ind);
}
void Flip(int ind, int l, int r, int ql, int qr)
{
    Push(ind);
    if (l>=ql && r<=qr)
    {
        seg[ind].lazy=true;
        return;
    }
    int mid=(l+r)/2;
    if (ql<=mid) Flip(ind*2,l,mid,ql,qr);
    if (qr>=mid+1) Flip(ind*2+1,mid+1,r,ql,qr);
    MakeRight(ind);
}
node qur;
void Query(int ind, int l, int r, int ql, int qr)
{
    Push(ind);
    if (l>=ql && r<=qr)
    {
        if (qur.len==0)
        {
            qur.len=seg[ind].len;
            qur.ll=seg[ind].ll;
            qur.rr=seg[ind].rr;
            qur.midsum[1]=seg[ind].midsum[1];
            qur.leftlen[1]=seg[ind].leftlen[1];
            qur.leftmks[1]=seg[ind].leftmks[1];
            qur.rightmks[1]=seg[ind].rightmks[1];
            qur.rightlen[1]=seg[ind].rightlen[1];
            return;
        }
        qur.midsum[1]+=seg[ind].midsum[1];
        long long nmks=max(qur.rightmks[1],seg[ind].leftmks[1]);
        if (qur.leftlen[1]!=qur.len && seg[ind].rightlen[1]!=seg[ind].len) qur.midsum[1]+=nmks;
        if (qur.leftlen[1]==qur.len) qur.leftmks[1]=max(qur.leftmks[1],seg[ind].leftmks[1]);
        if (qur.leftlen[1]==qur.len) qur.leftlen[1]+=seg[ind].leftlen[1];
        if (seg[ind].rightlen[1]==seg[ind].len)
        {
            qur.rightlen[1]=qur.rightlen[1]+seg[ind].rightlen[1];
            qur.rightmks[1]=max(qur.rightmks[1],seg[ind].rightmks[1]);
        }
        else
        {
            qur.rightlen[1]=seg[ind].rightlen[1];
            qur.rightmks[1]=seg[ind].rightmks[1];
        }
        qur.len+=seg[ind].len;
        qur.rr=seg[ind].rr;
        return;
    }
    int mid=(l+r)/2;
    if (ql<=mid) Query(ind*2,l,mid,ql,qr);
    if (qr>=mid+1) Query(ind*2+1,mid+1,r,ql,qr);
    MakeRight(ind);
}
int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);
    cin>>n>>qq;
    Initialise(1,1,n);
    for (int q=0;q<qq;q++)
    {
        int id;
        cin>>id;
        if (id==1 || id==2)
        {
            int p;
            cin>>p;
            Flip(1,1,n,p+1,n);
        }
        if (id==3)
        {
            int cc;
            long long aa;
            cin>>cc>>aa;
            Update(1,1,n,cc,aa);
        }
        if (id==4)
        {
            int l,r;
            cin>>l>>r;
            qur.reset();
            Query(1,1,n,l,r);
            long long ans=qur.midsum[1];
            //cout<<ans<<" ";
            ans+=qur.rightmks[1];
            //cout<<ans<<" ";
            if (qur.leftlen[1]!=qur.len) ans+=qur.leftmks[1];
            //cout<<ans<<" ";
            cout<<ans<<"\n";
        }
    }
}
