#include "zeroes.h"
///#include "Lgrader.cpp"
#define endl '\n'
using namespace std;

int n0;
int dx[] = {0, -1, 1,  0, 0};
int dy[] = {0,  0, 0, -1, 1};

const int INF = (1ll << 16) - 1;

unsigned short int get_mem (int x, int y);
void set_mem (int x, int y, unsigned short int value);

void f(int x, int y, int z)
{
    if (get_mem(n0, 1) == INF) set_mem(n0, 1, x * n0 + y);

    int x1 = get_mem(n0, 1) / n0;
    int y1 = get_mem(n0, 1) % n0;
    if (x1 + dx[z] < 0 or n0 <= x1 + dx[z])
    {
        set_mem(n0, 1, INF);
        return;
    }
    if (y1 + dy[z] < 0 or n0 <= y1 + dy[z])
    {
        set_mem(n0, 1, INF);
        return;
    }

    x1 += dx[z];
    y1 += dy[z];
    set_mem(n0, 1, x1 * n0 + y1);
    ///cout << x1 << " " << y1 << endl;

    int val = get_mem(x1, y1);
    if (val == 0) set_mem(n0, 1, INF);
    else set_mem(x1, y1, INF);
}

bool solve(int n, int call)
{
    n0 = n;
    if (n == 1) return true;

    int x0 = get_mem(n, 0) / (6 * n);
    int y0 = get_mem(n, 0) % (6 * n) / 6;
    int z = get_mem(n, 0) % 6;

    if (z == 0)
    {
        set_mem(n, 0, 1);
        set_mem(n, 1, INF);
        return false;
    }

    if (z != 5)
    {
        int val = get_mem(x0, y0);

        if (val == 0) f(x0, y0, z);

        if (get_mem(n, 1) != INF) return false;

        if (y0 < n - 1) y0++;
        else if (y0 == n - 1)
        {
            if (x0 < n - 1)
            {
                x0++;
                y0 = 0;
            }
            else
            {
                z++;
                x0 = y0 = 0;
            }
        }
        set_mem(n, 0, x0 * 6 * n + y0 * 6 + z);
        return false;
    }

    if (z == 5)
    {
        int val = get_mem(x0, y0);
        if (val == INF) set_mem(x0, y0, 0);
        if (y0 < n - 1) y0++;
        else if (y0 == n - 1)
        {
            if (x0 < n - 1)
            {
                x0++;
                y0 = 0;
            }
            else return true;
        }
        set_mem(n, 0, x0 * 6 * n + y0 * 6 + z);
        return false;
    }
}
