#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
using namespace std;
vector <int> graf[5024];
pair<int, int> kolkovlizat[5024];
int state[5024];
int otg = 1;
void dfs(int tek){
    if(state[tek] == 1){
        otg = 0;
        return ;
    }else{
        state[tek] = 1;
    }
    for(int i = 0; i < graf[tek].size(); i ++){
        dfs(graf[tek][i]);
    }
    state[tek] = 2;

}
int main (){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int N, M;
    cin>>N>>M;
    for(int i = 0; i < M; i ++){
        int a, b;
        cin>>a>>b;
        graf[a].push_back(b);
        kolkovlizat[b - 1].first++;
        kolkovlizat[b - 1].second = b;
        kolkovlizat[a - 1].first = kolkovlizat[a - 1].first;
        kolkovlizat[a - 1].second = a;
    }
    sort(kolkovlizat, kolkovlizat + N);
    /*for(int i = 0; i < N; i ++){
        cout<<kolkovlizat[i].second<<" "<<kolkovlizat[i].first<<endl;
    }*/
    int nach = kolkovlizat[0].second;
    ///cout<<nach;
    dfs(nach);
    cout<<otg;
    return 0;
}
/**
5 5
1 2
2 3
4 3
5 4
1 5

8 10
6 1
6 4
6 7
1 5
5 3
4 3
4 8
8 2
2 3
7 2
*/
