#include <bits/stdc++.h>
using namespace std;

const int MNOGO = INT_MAX/2;
const int MAXN = 5007;

int8_t G[MAXN][MAXN];
int n, m;
bool vis[MAXN];

int dijkstra(int b){
    vector<int> dist(n);
    for(int i = 0; i < n; i++){
        dist[i] = MNOGO;
    }

    priority_queue<tuple<int, int, int>> pq;
    pq.push({-MNOGO, b, -1});
    while(!pq.empty()){
        int kur = get<1>(pq.top());
        int kurd = -get<0>(pq.top());
        int from = get<2>(pq.top());
        pq.pop();

        if(dist[kur] < kurd){ continue; }
        dist[kur] = kurd;
        for(int i = 0; i < n; i++){
            if(G[kur][i] == 0 || i == from){ continue; }
            int dst = kurd;
            if(kur == b){ dst = 0; }
            if(G[kur][i] == -1){ dst += 1; }
            if(i == b){ cout << "\t\t!!!\n"; }
            cout << kur+1 << " -> " << i+1 << " : " << dst << '\n';
            if(dst < dist[i]){
                cout << "\tpush\n";
                pq.push({-dst, i, kur});
                dist[i] = dst;
            }
        }
    }

    return dist[b];
}

//int cycle(int b){
//    if(vis[b]){ return 1; }
//    vis[b] = true;
//    for(int i = 0; i < n; i++){
//        int nxt = G[b][i];
//        if(nxt != 1){ continue; }
//
//        int res = cycle(nxt);
//        if(res > 0){
//            vis[b] = false;
//            return res+1;
//        }
//    }
//    vis[b] = false;
//    return 0;
//}

int main(){
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--; v--;
        G[u][v] = 1;
        G[v][u] = -1;
    }

    int dij = dijkstra(1);
    cout << "dij: " << dij << '\n';


    return 0;
}
