#include <iostream>

using namespace std;

int nums[50][50];
int n;
int k;

bool fail[10000000];

int len(int num)
{
    int res = 0;
    while (num > 0)
    {
        res += num % 2;
        num /= 2;
    }
    return res;
}

int removeLeftBit(int num)
{
    return num & ((1 << (len(num) - 1)) - 1);
}

bool trySubset(int mask)
{
    if (fail[removeLeftBit(mask)])
    {
        fail[mask] = true;
        return false;
    }
    int targetArr[50];
    int ti = 0;
    int tq = 0;
    for (int i = 0; i < n; i++)
    {
        if (mask & (1 << i))
        {
            targetArr[ti] = nums[i][0];
            ti++;
        }
    }

    tq = ti;

    // for (int i = 0; i < ti; i++)
    // {
    //     cout << targetArr[i] << " ";
    // }
    // cout << endl;

    for (int j = 0; j < k; j++)
    {
        ti = 0;
        for (int i = 0; i < n; i++)
        {
            if (targetArr[ti] == nums[i][j])
            {
                ti++;
            }
        }
        if (ti != tq)
        {
            fail[mask] = true;
            return false;
        }
    }

    return true;
}

int main()
{
    cin >> n;
    cin >> k;

    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < n; j++)
        {
            cin >> nums[j][i];
        }
    }

    int upto = 1 << n;
    int best = 0;
    for (int i = 0; i < upto; i++)
    {
        if (trySubset(i) && len(i) > len(best))
        {
            best = i;
        }
    }

    cout << len(best);
}
