#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e6+1, BEGIN=0, END=1;
int N;
vector<tuple<int, int, int>> intervals;
pair<int, int> indexses[MAXN];
int prefix[2*MAXN], active_prefix[2*MAXN];


void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int i=0; i<N; i++)
    {
        int S, E;
        cin >> S >> E;
        intervals.push_back({S, BEGIN, i});
        intervals.push_back({E, END, i});
    }

    sort(intervals.begin(), intervals.end());
}

void Solve()
{
    int counter=0;

    for(int i=0; i<intervals.size(); i++)
    {
        if(get<1>(intervals[i])==BEGIN)
        {
            indexses[get<2>(intervals[i])].first=i;
        }
        else
        {
            indexses[get<2>(intervals[i])].second=i;
        }

        if(get<1>(intervals[i])==BEGIN)
        {
            counter++;
        }

        prefix[i]=counter;
    }

    counter=0;

    for(int i=0; i<intervals.size(); i++)
    {
        active_prefix[i]=counter;

        if(get<1>(intervals[i])==BEGIN)
        {
            counter++;
        }
        else
        {
            counter--;
        }
    }

    for(int i=0; i<N; i++)
    {
        int a=indexses[i].first, b=indexses[i].second;
        int ans=active_prefix[a]+(prefix[b]-prefix[a-1])-1;
        cout << ans << ' ';
    }
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}
