#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+1;
int N, K;
long L;
long d[MAXN];
long long prefix[MAXN];
int visited[MAXN];

void FastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> L;

    for(int i=0; i<N-1; i++)
    {
        cin >> d[i];
    }

    for(int i=1; i<N; i++)
    {
        prefix[i]=prefix[i-1]+d[i-1];
    }
}

void Solve()
{
    int ans=0;

    while(K!=0)
    {
        long Max=0;
        int MaxI;

        for(int i=0; i<N; i++)
        {
            int Current=1;

            if(visited[i]==1)
            {
                Current=0;
            }

            for(int j=i-1; j>=0; j--)
            {
                if(prefix[i]-prefix[j]>L || visited[j]==1)
                {
                    break;
                }

                Current++;
            }

            for(int j=i+1; j<N; j++)
            {
                if(prefix[j]-prefix[i]>L || visited[j]==1)
                {
                    break;
                }

                Current++;
            }

            if(Current>Max)
            {
                Max=Current;
                MaxI=i;
            }
        }

        ///cout << Max << " " << MaxI << '\n';

        if(Max==0)
        {
            break;
        }

        visited[MaxI]=1;

        for(int j=MaxI-1; j>=0; j--)
        {
            if(prefix[MaxI]-prefix[j]>L)
            {
                break;
            }

            visited[j]=1;
        }

        for(int j=MaxI+1; j<N; j++)
        {
            if(prefix[j]-prefix[MaxI]>L)
            {
                break;
            }

            visited[j]=1;
        }

        ans+=Max;
        K--;
    }

    cout << ans;
}

int main()
{
    FastIO();
    Read();
    Solve();
    return 0;
}

