#include <bits/stdc++.h>
using namespace std;

unsigned long long a[300000], b[300000];
unsigned long long n, m;

bool check(unsigned long long ans) {
    unsigned long long rest = 0;

    for (int i = 0; i < n; i++) {
        unsigned long long points = 0, hours = 0;

        if (a[i] > b[i]) {
            hours += min(m, (ans - 1) / a[i] + 1);
            points = hours * a[i];

            if (points < ans) {
                hours += (ans - points - 1) / b[i] + 1;
            }

        } else {
            hours += (ans - 1) / b[i] + 1;
        }

        rest += hours;
    }

    return rest <= n * m;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];


    unsigned long long l = 0, r = 0, ans = 0;

    for (int i = 0; i < n; i++) {
        r = max({r, a[i], b[i]});
    }

    r *= m;

    while (l <= r) {
        unsigned long long mid = (l / 2) + (r / 2) + (l % 2 + r % 2) / 2;

        if (check(mid)) {
            ans = mid;
            l = mid + 1;
        } else r = mid - 1;
    }

    cout << ans << endl;
    return 0;

}

