#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

const int N_max = 1e5 + 1;
const int K_max = 501;
const ll dL_max = 1e10;

int N, K, L;

int d[N_max];
bool visited[N_max];

bool cmp(pair <int, int> &a, pair <int, int> &b)
{
    int sz1 = a.second - a.first + 1, sz2 = b.second - b.first + 1;

    if (sz1 != sz2)
    {
        return sz1 > sz2;
    }

    return a.first < b.first;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> K >> L;

    for (int i = 1; i < N; i++)
    {
        cin >> d[i];
    }

    vector < pair <int, int> > info;

    for (int i = 1; i <= N; i++)
    {
        int maxLeft = 0, maxRight;
        int sum = 0;

        for (int q = i - 1; q >= 1; q--)
        {
            if (sum + d[q] <= L)
            {
                maxLeft = q;
                sum += d[q];
            }
            else
            {
                break;
            }
        }

        sum = 0;

        for (int q = i; q < N; q++)
        {
            if (sum + d[q] <= L)
            {
                maxRight = q + 1;
                sum += d[q];
            }
            else
            {
                break;
            }
        }

        if (maxLeft == 0)
        {
            maxLeft++;
        }

        info.push_back({maxLeft, maxRight});

        ///cout << "m; " << maxLeft << " " << maxRight << endl;
    }

    sort(info.begin(), info.end(), cmp);

    int ans = 0;

    /**for (int i = 0; i < info.size(); i++)
    {
        cout << info[i].first << " " << info[i].second << endl;
    }**/

    for (int i = 0; i < K; i++)
    {
        for (int q = info[i].first; q <= info[i].second; q++)
        {
            visited[q] = 1;
        }
    }

    for (int i = 1; i <= N; i++)
    {
        if (visited[i] == 1)
        {
            ans++;
        }
    }

    cout << ans << endl;

    return 0;
}
