#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

const int N_max = 1e5 + 1;
const int K_max = 501;
const ll dL_max = 1e10;

int N, K, L;

int d[N_max];
vector < pair <int, int> > info;
bool f[N_max];
bool p[N_max];

int rec(int br)
{
    if (br == K)
    {
        for (int i = 0; i <= N; i++)
        {
            f[i] = 0;
        }

        int houses = 0;
        vector <int> idx;

        for (int i = 0; i < N; i++)
        {
            if (p[i])
            {
                idx.push_back(i);
            }
        }

        for (int i = 0; i < idx.size(); i++)
        {
            for (int q = info[idx[i]].first; q <= info[idx[i]].second; q++)
            {
                f[q] = 1;
            }
        }

        for (int i = 1; i <= N; i++)
        {
            if (f[i])
            {
                houses++;
            }
        }

        ///cout << idx[0] << " " << idx[1] << " " << houses << endl;

        return houses;
    }

    int ans = 0;

    for (int i = 1; i <= N; i++)
    {
        if (p[i])
        {
            continue;
        }

        p[i] = 1;
        ans = max(ans, rec(br + 1));
        p[i] = 0;
    }

    return ans;
}

void solve20()
{
    int ans = rec(0);

    cout << ans << endl;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> K >> L;

    for (int i = 1; i < N; i++)
    {
        cin >> d[i];
    }

    for (int i = 1; i <= N; i++)
    {
        int maxLeft, maxRight;
        bool o = 0;
        ll sum = 0;

        for (int q = i - 1; q >= 1; q--)
        {
            if (sum + d[q] <= L)
            {
                o = 1;
                maxLeft = q;
                sum += d[q];
            }
            else
            {
                break;
            }
        }

        if (!o)
        {
            maxLeft = i;
        }

        o = 0;
        sum = 0;

        for (int q = i; q < N; q++)
        {
            if (sum + d[q] <= L)
            {
                o = 1;
                maxRight = q + 1;
                sum += d[q];
            }
            else
            {
                break;
            }
        }

        if (!o)
        {
            maxRight = i;
        }

        info.push_back({maxLeft, maxRight});
    }


    if (N <= 20)
    {
        solve20();
    }

    return 0;
}
